// SaveGameMgr 0.4

// wb_[
#include <pspkernel.h>
#include <systemctrl.h>
#include <psputility.h>
#include <pspinit.h>
#include <pspsdk.h>
#include <string.h>
#include <stdio.h>
#include "memory.h"
#include "filemgr.h"

// W[̐ݒ
PSP_MODULE_INFO("SaveGameMgr", 0x1000, 0, 3);

// `
#define		PSP_SAVEDATA_PATH		"ms0:/PSP/SAVEDATA"
#define		DUMP_SAVEDATA_PATH		"ms0:/SAVEPLAIN/Dump"

// O[oϐ
u32 orgaddr[2];
int (*sceUtilitySavedataInitStart_Real)(SceUtilitySavedataParam *);
int (*sceUtilitySavedataShutdownStart_Real)(void);
int savedata_size = 0;
int load_mode = 0;
int first_save = 0;
char *gptr = NULL;
char *sptr = NULL;
void *savedata_ptr = NULL;

// ֐
int Get_SaveName(char *name, const char *gptr, const char *sptr)
{
	// ƃX}[gȕ@Ȃȁc

	SceUID dfd;
	char buff[128];

	// Z[uf[^擾
	sprintf(name, "%s%s", gptr, sptr);

	// ۂɂ邩m߂
	sprintf(buff, "%s/%s", PSP_SAVEDATA_PATH, name);
	dfd = sceIoDopen(buff);
	if(dfd < 0)
	{
		// Z[uf[^擾
		strcpy(name, gptr);

		// ۂɂ邩m߂
		sprintf(buff, "%s/%s", PSP_SAVEDATA_PATH, name);
		dfd = sceIoDopen(buff);
		if(dfd < 0)
		{
			return -1;
		}
	}

	sceIoDclose(dfd);
	return 0;
}

// Rs[Xbh
int copy_thread(SceSize args, void *argp)
{
	// eLg[ɃfBC
	sceKernelDelayThread(3 * 1000 * 1000);

	char psp_path[128];
	char old_path[128];
	char new_path[128];

	sprintf(psp_path, "%s/%s%s", PSP_SAVEDATA_PATH, gptr, sptr);
	sprintf(old_path, "%s/%s", DUMP_SAVEDATA_PATH, gptr);
	sprintf(new_path, "%s/%s%s", DUMP_SAVEDATA_PATH, gptr, sptr);

	SceUID dfd = sceIoDopen(psp_path);
	if(dfd > 0)
	{
		Copy_dir(old_path, new_path);
		Remove_dir(old_path);
		sceIoDclose(dfd);
	}

	return 0;
}

// pb`֐
int sceUtilitySavedataInitStart_Patched(SceUtilitySavedataParam *params)
{
	int k1 = pspSdkSetK1(0);
	int rs = 0;

	// gameNamẽ̕AhX擾Ă
	gptr = params->gameName;

	// saveNamẽ̕AhX擾Ă
	sptr = params->saveName;

	// [h
	if(params->mode == PSP_UTILITY_SAVEDATA_AUTOLOAD || params->mode == PSP_UTILITY_SAVEDATA_LOAD || params->mode == PSP_UTILITY_SAVEDATA_LISTLOAD)
	{
		load_mode = 1;

		// Z[uf[^ǂݍ܂AhX擾Ă
		savedata_ptr = params->dataBuf;
	}

	// Z[u
	if(params->mode == PSP_UTILITY_SAVEDATA_AUTOSAVE || params->mode == PSP_UTILITY_SAVEDATA_SAVE || params->mode == PSP_UTILITY_SAVEDATA_LISTSAVE)
	{
		load_mode = 0;

		// _vtH_̍쐬
		char dpath[128];
		char buff[128];

		// tH_擾
		if(Get_SaveName(dpath, params->gameName, params->saveName) < 0)
		{
			// 擾s
			first_save = 1;
		}

		// tH_쐬
		sprintf(buff, "%s/%s", DUMP_SAVEDATA_PATH, dpath);
		Make_dir(buff);

		// ÍZ[uf[^̃_v
		sprintf(buff, "%s/%s/SDDATA.bin", DUMP_SAVEDATA_PATH, dpath);

		SceUID raw = sceIoOpen(buff, PSP_O_WRONLY | PSP_O_CREAT | PSP_O_TRUNC, 0777);
		if(raw > 0)
		{
			sceIoWrite(raw, params->dataBuf, params->dataBufSize);
			sceIoClose(raw);
		}

		// Gamekeỹ_v(̍\̂0x5DCZAhX16byteGamekey)
		sprintf(buff, "%s/%s/%s.bin", DUMP_SAVEDATA_PATH, dpath, params->gameName);

		SceUID key = sceIoOpen(buff, PSP_O_WRONLY | PSP_O_CREAT | PSP_O_TRUNC, 0777);
		if(key > 0)
		{
			char gamekey[16];
			memcpy(gamekey, (void *)((int)params + 0x5DC), 16);
			sceIoWrite(key, (void *)gamekey, 16);
			sceIoClose(key);
		}

		// SceUtilitySavedataParam\̂̃_v
		sprintf(buff, "%s/%s/SavedataParam.bin", DUMP_SAVEDATA_PATH, dpath);

		SceUID param = sceIoOpen(buff, PSP_O_WRONLY | PSP_O_CREAT | PSP_O_TRUNC, 0777);
		if(param > 0)
		{
			sceIoWrite(param, (void *)params, sizeof(SceUtilitySavedataParam));
			sceIoClose(param);
		}
	}

	// Z[uf[^
	rs = sceUtilitySavedataInitStart_Real(params);

	pspSdkSetK1(k1);
	return rs;
}

int sceUtilitySavedataShutdownStart_Patched(void)
{
	int k1 = pspSdkSetK1(0);
	int rs = sceUtilitySavedataShutdownStart_Real();

	if(load_mode)
	{
		load_mode = 0;

		// ÍZ[uf[^̃pX
		char name[128];
		char load_path[128];

		// tH_擾
		Get_SaveName(name, gptr, sptr);

		// pX
		sprintf(load_path, "%s/%s/SDDATA.bin", DUMP_SAVEDATA_PATH, name);

		// ÍZ[uf[^̃TCY擾
		savedata_size = Get_size(load_path);

		// ÍZ[uf[^̓ǂݍ
		SceUID raw = sceIoOpen(load_path, PSP_O_RDONLY, 0777);
		if(raw > 0)
		{
			int size, adr, res, i, n;
			void *buff;

			// mۂ郁ʂvZ
			size = Caluc_memory(savedata_size, &n);

			// m
			buff = (void *)malloc_p(size);
			if(buff != NULL)
			{
				// Z[uf[^̃AhXɃRs[
				for(i = adr = 0; i < n; i++)
				{
					res = sceIoRead(raw, buff, size);
					memcpy((savedata_ptr + adr), buff, res);
					adr += res;
				}

				// 
				free_p(buff);
			}

			sceIoClose(raw);
		}
	}

	if(first_save)
	{
		first_save = 0;

		// Rs[Xbh쐬
		SceUID thid = sceKernelCreateThread("Copy_Dir", copy_thread, 32, 0x900, 0, NULL);
		if (thid >= 0)sceKernelStartThread(thid, 0, 0);
	}

	pspSdkSetK1(k1);
	return rs;
}

int module_start(SceSize args, void *argp)
{
	// Q[[hł̂ݓ삷
	if(sceKernelInitKeyConfig() == PSP_INIT_KEYCONFIG_GAME)
	{
		// tH_쐬
		Make_dir("ms0:/SAVEPLAIN");
		Make_dir(DUMP_SAVEDATA_PATH);

		// pb`
		orgaddr[0] = sctrlHENFindFunction("sceUtility_Driver", "sceUtility", 0x50C4CD57);
		orgaddr[1] = sctrlHENFindFunction("sceUtility_Driver", "sceUtility", 0x9790B33C);

		sceUtilitySavedataInitStart_Real = (void *)orgaddr[0];
		sceUtilitySavedataShutdownStart_Real = (void *)orgaddr[1];

		sctrlHENPatchSyscall(orgaddr[0], sceUtilitySavedataInitStart_Patched);
		sctrlHENPatchSyscall(orgaddr[1], sceUtilitySavedataShutdownStart_Patched);

		sceKernelDcacheWritebackAll();
		sceKernelIcacheClearAll();
	}

	return 0;
}

int module_stop(SceSize args, void *argp)
{
	sctrlHENPatchSyscall((u32)sceUtilitySavedataInitStart_Patched, (void *)orgaddr[0]);
	sctrlHENPatchSyscall((u32)sceUtilitySavedataShutdownStart_Patched, (void *)orgaddr[1]);

	sceKernelDcacheWritebackAll();
	sceKernelIcacheClearAll();

	return 0;
}

